# Copyright (c) 2018 Dave Love, University of Manchester
# Licence: MIT

# Fixme: rpmlint warnings about FSF address
#        el6's texinfo seems too old -- gives formatting errors
#        Fails on f29, and rawhide (in copr only):
#        src/histogram_widget.c: In function 'gtk_histogram_class_init':
#        src/histogram_widget.c:105:30: error: 'g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE' undeclared (first use in this function); did you mean 'g_cclosure_marshal_VOID__DOUBLEv'?
#                                      g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE,
#                                      ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%global verdate 20171106

Name:		aftermath
Version:	0
Release:	2.%verdate%{?dist}
Summary:	Trace-based Performance Analysis for OpenMP and OpenStream
License:	GPLv2 and LGPLv2 and GFDL
URL:		https://www.aftermath-tracing.com/
# By git archive from git://git.drebesium.org/aftermath.git
Source0:	aftermath-%verdate.tar.gz
# Fix format security warning
Patch1:		aftermath-format.patch
# Support ppc64 and aarch timers (not currently useful, as below)
Patch2:		aftermath-arch.patch
BuildRequires:	automake gcc glib2-devel libglade2-devel gtk2-devel libtool
BuildRequires:	texinfo numpy pkgconfig
# Testing only, but the test fails, as below
# BuildRequires:	valgrind
# Build fails with list.h from contrib/linux-kernel on ppc64le and
# aarch even when timers are supplied.
ExclusiveArch:	%ix86 x86_64


%description
Aftermath is a graphical tool for the trace-based performance analysis
of OpenMP and OpenStream programs.  The tool allows programmers to
relate performance data from a parallel execution to the programming
model, e.g. to loops and tasks in OpenMP.  Aftermath supports the
interactive exploration of trace files, the generation of detailed
statistics for arbitrary subsets of a trace on-the-fly and the
inspection of individual events in detail.

%package libs
Summary: Library support for the Aftermath trace format

%description libs
Library support for the Aftermath trace format.

%package devel
Summary: Development file for the Aftermath trace format
Requires: %name-libs%{?_isa} = %version-%release

%description devel
Development file for the Aftermath trace format.


%prep
%setup -q
%patch1 -p1 -b .orig
%patch2 -p1 -b .orig
./bootstrap
mkdir -p src/generated
find examples -name .gitignore -delete


%build
%configure --disable-static
%make_build


%install
%make_install


%ldconfig_postun

%post
if [ -f %_infodir/bashdb.info.gz ]; then
  /sbin/install-info \
    --info-dir=%_infodir %_infodir/bashdb.info.gz || :
fi
%ldconfig

%preun
if [ $1 = 0 -a -f %_infodir/bashdb.info.gz ]; then
  /sbin/install-info --delete \
    --info-dir=%_infodir %_infodir/bashdb.info.gz || :
fi


%check
make check
# lt-counter_event_set_index_test fails with a leak error
# make valgrind-check


%files
%license COPYING*
%doc README ChangeLog AUTHORS examples
%_bindir/*
%_mandir/man1/aftermath.1*
%exclude %_libdir/libaftermath-*la
%_datadir/aftermath
%exclude %_infodir/dir
%_infodir/openmp-shortguide*

%files libs
%_libdir/libaftermath-*.so.*

%files devel
%_libdir/libaftermath-*.so
%_includedir/aftermath


%changelog
* Mon Nov 26 2018 Dave Love <loveshack@fedoraproject.org> - 0-2.20171106
- Separate the library

* Fri Nov  2 2018 Dave Love <loveshack@fedoraproject.org> - 0-1.20171106
- Initial packaging
